=encoding utf8

=head1 NAME

Mail::Message::TransferEnc - message transfer encoder/decoder

=head1 INHERITANCE

 Mail::Message::TransferEnc
   is a Mail::Reporter

 Mail::Message::TransferEnc is extended by
   Mail::Message::TransferEnc::Base64
   Mail::Message::TransferEnc::Binary
   Mail::Message::TransferEnc::EightBit
   Mail::Message::TransferEnc::QuotedPrint
   Mail::Message::TransferEnc::SevenBit

=head1 SYNOPSIS

  my Mail::Message $msg = ...;
  my $decoded = $msg->decoded;
  my $encoded = $msg->encode(transfer => 'base64');

=head1 DESCRIPTION

This class is the base for various encoders and decoders, which are
used during transport of the message.  These packages, and all which are
derived, are invoked by the message's L<Mail::Message::decoded()|Mail::Message/"The body"> and
L<Mail::Message::encode()|Mail::Message/"The body"> methods:

  my $message = $folder->message(3);
  my $decoded_body = $message->decoded;
  my $encoded_body = $message->encode(transfer => 'base64');

Rules for transfer encodings are specified in RFC4289.  The full list
of permissible content transfer encodings can be found at
L<https://www.iana.org/assignments/transfer-encodings/transfer-encodings.xhtml>

The following coders/decoders are currently supported (April 2025, the full
list at IANA):

=over 4

=item * L<Mail::Message::TransferEnc::Base64|Mail::Message::TransferEnc::Base64>

C<base64> for binary information.

=item * L<Mail::Message::TransferEnc::SevenBit|Mail::Message::TransferEnc::SevenBit>

C<7bit> for plain old ASCII characters only.

=item * L<Mail::Message::TransferEnc::EightBit|Mail::Message::TransferEnc::EightBit>

C<8bit> for extended character set data, not encoded.

=item * L<Mail::Message::TransferEnc::QuotedPrint|Mail::Message::TransferEnc::QuotedPrint>

C<quoted-printable> encdoded extended character set data.

=back

Extends L<"DESCRIPTION" in Mail::Reporter|Mail::Reporter/"DESCRIPTION">.

=head1 METHODS

Extends L<"METHODS" in Mail::Reporter|Mail::Reporter/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Reporter|Mail::Reporter/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Reporter/"Constructors">

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Reporter|Mail::Reporter/"Attributes">.

=head2 The Encoder

=over 4

=item $class-E<gt>B<addTransferEncoder>($type, $class)

Adds one new encoder to the list known by the L<Mail::Box|Mail::Box> suite.  The
C<$type> is found in the message's header in the C<Content-Transfer-Encoding>
field.

=item $obj-E<gt>B<create>($type, %options)

Create a new coder/decoder based on the required type.

=item $obj-E<gt>B<name>()

The name of the encoder.  Case is not significant.

=back

=head2 Encoding

=over 4

=item $obj-E<gt>B<check>($body, %options)

Check whether the body is correctly encoded.  If so, the body reference is
returned with the C<checked> flag set.  Otherwise, a new object is created
and returned.

 -Option     --Default
  result_type  <type of source body>

=over 2

=item result_type => CLASS

The type of the body to be produced, when the checker decides to return
modified data.

=back

=item $obj-E<gt>B<decode>($body, %options)

Use the encoder to decode the content of C<$body>.  A new body is returned.

 -Option     --Default
  result_type  <type of source body>

=over 2

=item result_type => CLASS

The type of the body to be produced, when the decoder decides to return
modified data.

=back

=item $obj-E<gt>B<encode>($body, %options)

Use the encoder to encode the content of C<$body>.

 -Option     --Default
  result_type  <type of source body>

=over 2

=item result_type => CLASS

The type of the body to be produced, when the decoder decides to return
modified data.

=back

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Reporter|Mail::Reporter/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Reporter|Mail::Reporter/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DIAGNOSTICS

=over 4

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Error: decoder for transfer encoding $type does not work: $@

Compiling the required transfer encoding resulted in errors, which means
that the decoder can not be used.
Cast by C<create()>

=item Error: no decoder for transfer encoding $type.

A decoder for the specified type of transfer encoding is not implemented.
Cast by C<create()>

=back

=head1 SEE ALSO

This module is part of Mail-Message version 4.03,
built on January 26, 2026. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

